package implement

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/dao"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/utils/logx"
	"xorm.io/xorm"
)

func NewHappyOrchardRewardExchangeRecordsDb(engine *xorm.Engine) dao.HappyOrchardRewardExchangeRecordsDao {
	return &HappyOrchardRewardExchangeRecordsDb{Db: engine}
}

type HappyOrchardRewardExchangeRecordsDb struct {
	Db *xorm.Engine
}

func (h HappyOrchardRewardExchangeRecordsDb) UpdateHappyOrchardRewardExchangeRecordsBySess(sess *xorm.Session, m *models.HappyOrchardRewardExchangeRecords, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = sess.Where("id=?", m.Id).Cols(forceColums...).Update(m)
	} else {
		affected, err = sess.Where("id=?", m.Id).Update(m)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (h HappyOrchardRewardExchangeRecordsDb) InsertHappyOrchardRewardExchangeRecordsBySess(sess *xorm.Session, m *models.HappyOrchardRewardExchangeRecords) (int, error) {
	_, err := sess.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (h HappyOrchardRewardExchangeRecordsDb) GetHappyOrchardRewardExchangeRecords(id int) (m *models.HappyOrchardRewardExchangeRecords, err error) {
	//TODO implement me
	m = new(models.HappyOrchardRewardExchangeRecords)
	has, err := h.Db.Where("id =?", id).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (h HappyOrchardRewardExchangeRecordsDb) FindHappyOrchardRewardExchangeRecordsByUid(uid int) (mm *[]models.HappyOrchardRewardExchangeRecords, err error) {
	//TODO implement me
	var m []models.HappyOrchardRewardExchangeRecords
	if err := h.Db.Where("uid =?", uid).Desc("id").Find(&m); err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}
func (h HappyOrchardRewardExchangeRecordsDb) GetHappyOrchardRewardExchangeRecordsByUidWithState(uid, state int) (m *models.HappyOrchardRewardExchangeRecords, err error) {
	m = new(models.HappyOrchardRewardExchangeRecords)
	has, err := h.Db.Where("uid =? and state=?", uid, state).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}
func (h HappyOrchardRewardExchangeRecordsDb) GetHappyOrchardRewardExchangeRecordsByUidWithStateAndId(uid, id, state int) (m *models.HappyOrchardRewardExchangeRecords, err error) {
	m = new(models.HappyOrchardRewardExchangeRecords)
	has, err := h.Db.Where("uid =? and state=? and id=?", uid, state, id).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}
func (h HappyOrchardRewardExchangeRecordsDb) GetHappyOrchardRewardExchangeRecordsByRecordId(id int) (m *models.HappyOrchardRewardExchangeRecords, err error) {
	m = new(models.HappyOrchardRewardExchangeRecords)
	has, err := h.Db.Where("record_id=?", id).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}
