package implement

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/dao"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_model.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_model.git/utils/logx"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

func NewSuperCloudIssuanceRobotPackageDb(engine *xorm.Engine) dao.SuperCloudIssuanceRobotPackageDao {
	return &SuperCloudIssuanceRobotPackageDb{Db: engine}
}

type SuperCloudIssuanceRobotPackageDb struct {
	Db *xorm.Engine
}

func (s SuperCloudIssuanceRobotPackageDb) GetCloudIssuanceRobotPackage(id int) (m *models.SuperCloudIssuanceRobotPackage, err error) {
	m = new(models.SuperCloudIssuanceRobotPackage)
	has, err := s.Db.Where("id = ?", id).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (s SuperCloudIssuanceRobotPackageDb) FindSuperCloudIssuanceRobotPackage(params map[string]interface{}) (m []*models.SuperCloudIssuanceRobotPackage, err error) {
	if params["key"] == nil {
		//查询全部数据
		err := s.Db.OrderBy("sort DESC").Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := s.Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := s.Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return m, nil
		}
	}
}
