package models

type SuperCloudIssuanceBasic struct {
	Id                                    int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	IsOpenFreeAccess                      int    `json:"is_open_free_access" xorm:"not null default 0 comment('是否开启-免费使用权限') TINYINT(3)"`
	FreeAccess                            int    `json:"free_access" xorm:"not null comment('免费使用天数') TINYINT(3)"`
	MaxActivityGroupNums                  int    `json:"max_activity_group_nums" xorm:"not null comment('最大激活群数量') TINYINT(3)"`
	UseAccess                             int    `json:"use_access" xorm:"not null default 0 comment('使用权限(会员等级)') TINYINT(3)"`
	TimeIntervalIssuanceOnCircleOfFriends int    `json:"time_interval_issuance_on_circle_of_friends" xorm:"not null default 10 comment('朋友圈发单时间间隔(分钟)') TINYINT(3)"`
	TimeIntervalIssuanceOnGroups          int    `json:"time_interval_issuance_on_groups" xorm:"not null default 10 comment('群发单时间间隔(分钟)') TINYINT(3)"`
	TimeSlotIssuanceOnDefault             string `json:"time_slot_issuance_on_default" xorm:"not null comment('默认发单时间段') TEXT"`
	SendGroupFormat                       int    `json:"send_group_format" xorm:"not null default 1 comment('发群格式(1:先商品图片后商品文案 2:先商品文案后商品图片)') TINYINT(1)"`
	DefaultAddGroupWelcomeMessage         string `json:"default_add_group_welcome_message" xorm:"not null default '' comment('默认加群欢迎语') VARCHAR(255)"`
	DefaultNewFriendGreeted               string `json:"default_new_friend_greeted" xorm:"not null default '' comment('默认新好友打招呼') VARCHAR(255)"`
	CreateAt                              string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateAt                              string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
}
